using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Repository_Operation
	/// </summary>
	public partial class T_Repository_Operation
    {
        public T_Repository_Operation()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Repository_Operation");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Repository_Operation model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Repository_Operation(");
            strSql.Append("F_RepositoryId,F_AuditId,F_LogId,F_OptType,F_OptContent,F_State,F_OptBy,F_OptOn,F_Reason)");
            strSql.Append(" values (");
            strSql.Append("@F_RepositoryId,@F_AuditId,@F_LogId,@F_OptType,@F_OptContent,@F_State,@F_OptBy,@F_OptOn,@F_Reason)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_AuditId", SqlDbType.Int,4),
                    new SqlParameter("@F_LogId", SqlDbType.Int,4),
                    new SqlParameter("@F_OptType", SqlDbType.Int,4),
                    new SqlParameter("@F_OptContent", SqlDbType.NVarChar),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_OptBy", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptOn", SqlDbType.DateTime),
                    new SqlParameter("@F_Reason", SqlDbType.NVarChar),
            };
            parameters[0].Value = model.F_RepositoryId;
            parameters[1].Value = model.F_AuditId;
            parameters[2].Value = model.F_LogId;
            parameters[3].Value = model.F_OptType;
            parameters[4].Value = model.F_OptContent;
            parameters[5].Value = model.F_State;
            parameters[6].Value = model.F_OptBy;
            parameters[7].Value = model.F_OptOn;
            parameters[8].Value = model.F_Reason;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Repository_Operation model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Repository_Operation set ");
            strSql.Append("F_RepositoryId=@F_RepositoryId,");
            strSql.Append("F_AuditId=@F_AuditId,");
            strSql.Append("F_LogId=@F_LogId,");
            strSql.Append("F_OptType=@F_OptType,");
            strSql.Append("F_OptContent=@F_OptContent,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_OptBy=@F_OptBy,");
            strSql.Append("F_OptOn=@F_OptOn,");
            strSql.Append("F_Reason=@F_Reason ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_AuditId", SqlDbType.Int,4),
                    new SqlParameter("@F_LogId", SqlDbType.Int,4),
                    new SqlParameter("@F_OptType", SqlDbType.Int,4),
                    new SqlParameter("@F_OptContent", SqlDbType.NVarChar),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_OptBy", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptOn", SqlDbType.DateTime),
                    new SqlParameter("@F_Reason", SqlDbType.NVarChar),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_RepositoryId;
            parameters[1].Value = model.F_AuditId;
            parameters[2].Value = model.F_LogId;
            parameters[3].Value = model.F_OptType;
            parameters[4].Value = model.F_OptContent;
            parameters[5].Value = model.F_State;
            parameters[6].Value = model.F_OptBy;
            parameters[7].Value = model.F_OptOn;
            parameters[8].Value = model.F_Reason;
            parameters[9].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Repository_Operation ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Repository_Operation ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Repository_Operation GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Repository_Operation ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Repository_Operation model = new CallCenterApi.Model.T_Repository_Operation();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_Id"] != null && ds.Tables[0].Rows[0]["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(ds.Tables[0].Rows[0]["F_Id"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_RepositoryId"] != null && ds.Tables[0].Rows[0]["F_RepositoryId"].ToString() != "")
                {
                    model.F_RepositoryId = int.Parse(ds.Tables[0].Rows[0]["F_RepositoryId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_AuditId"] != null && ds.Tables[0].Rows[0]["F_AuditId"].ToString() != "")
                {
                    model.F_AuditId = int.Parse(ds.Tables[0].Rows[0]["F_AuditId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_LogId"] != null && ds.Tables[0].Rows[0]["F_LogId"].ToString() != "")
                {
                    model.F_LogId = int.Parse(ds.Tables[0].Rows[0]["F_LogId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_OptType"] != null && ds.Tables[0].Rows[0]["F_OptType"].ToString() != "")
                {
                    model.F_OptType = int.Parse(ds.Tables[0].Rows[0]["F_OptType"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_OptContent"] != null )
                {
                    model.F_OptContent = ds.Tables[0].Rows[0]["F_OptContent"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_State"] != null && ds.Tables[0].Rows[0]["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(ds.Tables[0].Rows[0]["F_State"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_OptBy"] != null )
                {
                    model.F_OptBy = ds.Tables[0].Rows[0]["F_OptBy"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_OptOn"] != null && ds.Tables[0].Rows[0]["F_OptOn"].ToString() != "")
                {
                    model.F_OptOn = DateTime.Parse(ds.Tables[0].Rows[0]["F_OptOn"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Reason"] != null)
                {
                    model.F_Reason =ds.Tables[0].Rows[0]["F_Reason"].ToString();
                }
                
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Repository_Operation ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Repository_Operation ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Repository_Operation ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Repository_Operation T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  Method
    }
}
